package com.diagbot.facade;

import com.diagbot.client.AIServiceClient;
import com.diagbot.client.bean.Response;
import com.diagbot.client.bean.ResponseData;
import com.diagbot.dto.LisResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.web.bind.annotation.RequestBody;
import com.diagbot.vo.SearchVo;

import java.util.List;

/**
 * <p>
 *  数据处理业务层
 * </p>
 *
 * @author Mark Huang
 * @since 2019-03-04
 */
@Component
public class ClinicalFacade {

    @Autowired
    private AIServiceClient aiServiceClient;

    /**
     * 处理临床数据
     *
     * @param searchVo
     * @return ResponseData
     */
    public ResponseData processClinicalData(@RequestBody SearchVo searchVo) {
        processLis(searchVo);
        Response<ResponseData> res = aiServiceClient.bayesPageData(searchVo);

        return res.getData();
    }

    private void processLis(SearchVo sData) {

        String Otherval = "";
        String lisresult = "";
        List<LisResult> lisArr = sData.getLisArr();

        for (int i=0; i<lisArr.size(); i++) {
            LisResult lisres = lisArr.get(i);

            Otherval = (lisres.getOtherValue().trim().length() > 0)? lisres.getOtherValue().trim()+"\n":"";

            if (lisres.getMaxValue() != null && lisres.getValue() > lisres.getMaxValue()) {
                lisres.setOtherValue(Otherval + "\n" + lisres.getDetailName() + "升高");

            }
            else if (lisres.getMinValue() != null && lisres.getValue() < lisres.getMinValue()) {
                lisres.setOtherValue(Otherval + "\n" + lisres.getDetailName() + "下降");
            }
            lisresult += lisres.getOtherValue() + "\n";
        }

        sData.setLis(lisresult);
    }
}
